// Library		libSOCK - Machine independent Socket I/O functions.
// File:		SOCK_Accept.c
// Function:	SOCK_Accept
// Description:	Accept a connection on a socket returned by SOCK_Listen().
// 				Return a connected socket or -1.
// Author(s):	TECMAV srl - av/cb
// L.M. Date:	24-Sep-2003 (18:06:36)


#include "_libsock.h"
#include "libDPR.h"

int SOCK_Accept(int baseSock)
{
	struct sockaddr_in	soc;
	int					siz;
	int					sd;

	DPR1("[ SOCK_Accept(%d)\n", baseSock)

	siz = sizeof(struct sockaddr_in);
	memset (&soc, 0, siz);
	sd = accept (baseSock, (struct sockaddr *)(&soc), (SOCKL_T *)&siz);

	DPR_SOC(&soc)
	DPR2("] -> %d (errno=%d)\n", sd, errno)
	return(sd);
}
