// Library		libSOCK - Machine independent Socket I/O functions.
// File:        SOCK_DPR.c
// Function:	Detailed printout of a "soc" structure.
// Author(s):	TECMAV s.r.l. - av
// L.M. Date:	20-Sep-2003 (02:35:31)

#include "_libsock.h"
#include "libDPR.h"

void SOCK_DPR(void *X)
{
#ifdef DEBUG
	struct sockaddr_in *soc;
	int a,b,c,d;
	long l;

	soc = (struct sockaddr_in *)X;

	l = soc->sin_addr.s_addr;
	a = l & 0xFF; l >>= 8;
	b = l & 0xFF; l >>= 8;
	c = l & 0xFF; l >>= 8;
	d = l & 0xFF;

	switch (soc->sin_family)
	{
		case AF_INET: DPR1("family = AF_INET (%d)",soc->sin_family)
		              break;
		default     : DPR1("family = ??????? (%d)",soc->sin_family)
		         	  break;
	}

	DPR2(" - port=%u(%u)",
		ntohs(soc->sin_port), soc->sin_port)

#ifdef Os_ECOS
	DPR1(" - len=%d", soc->sin_len)
#endif

	if (l != ntohl(l))			
		DPR4(" - host_addr = %d.%d.%d.%d\n", a, b, c, d)
	else
		DPR4(" - host_addr = %d.%d.%d.%d\n", d, c, b, a)
#endif
}
