// Library		libSOCK - Machine independent Socket I/O functions.
// File:		SOCK_SAddr.c
// Function:	SOCK_SAddr
// Descrizione:	Dato un descrittore socket, restituisce l'indirizzo IP del-
//				l'host connesso in:
//				- ip_str: formato ASCII puntatose, se ip_str e` non nullo.
//				- ip_int: formato intero, se ip_int e` non nullo.
//				Restituisce 0 se non ci sono errori, se non -1 + errno.
//				Se entrmbi gli argomenti di output sono nulli, non resti-
//				tuisce nulla, indica solo se il socket e` aperto o no.
// Author(s):	TECMAV srl - av/cb
// L.M. Date:	26-Apr-2003 (23:03:55)

#include "_libsock.h"

int SOCK_SAddr(int sd, char *ip_str, int *ip_int)
{
	int soc_size;

	union
	{
		int i;
		struct
		{
			unsigned char a;
			unsigned char b;
			unsigned char c;
			unsigned char d;
		}b;
	}
	u1;

	struct sockaddr_in	soc;
	soc_size = sizeof(soc);

	if (getpeername(sd, (struct sockaddr *)(&soc), (SOCKL_T *)&soc_size)) 
		return(-1);

    u1.i = soc.sin_addr.s_addr;


	// Lo standard di rete e` 68K (MSb a indirizzo basso)

	if (ip_str)
		sprintf(ip_str, "%d.%d.%d.%d", u1.b.a, u1.b.b, u1.b.c, u1.b.d);

	if (ip_int) *ip_int = ntohl(u1.i);				// Standard di host.

	return(0);
}
