// Library		libSOCK - Machine independent Socket I/O functions.
// File:		SOCK_Send.c
// Function:	SOCK_Send
// Descrizione: Invia un messaggio su "peer" mediante sendto().
//				Restituisce il numero di caratteri letti o -1.
// Author(s):	TECMAV srl - av
// L.M. Date:	05-Dec-2003 (15:30:30)

#include "_libsock.h"
#include "libDPR.h"


int SOCK_Send(SockPeer_t *peer, char *msg, int size)
{
	int scritti;				// Byte mandati da sendto() o -1.


	DPR3("[ SOCK_Send(peer=0x%X, msg=0x%x, size=%d)\n",
		(int)peer, (int)msg, size)

	errno = 0;

	scritti = sendto(	peer->sd,
						msg,
						(size_t)size,
						0,
						(struct sockaddr *)(peer->soc),
						sizeof(struct sockaddr_in)
					);

	DPR3("] ret=%d, errno=%d=%s\n", scritti, errno, CML_EStr())

	return(scritti);
}
