// Library		libSOCK - Machine independent Socket I/O functions.
// File:		SOCK_pthRecv.c
// Function:	SOCK_pthRecv
// Descrizione: Legge un messaggio da "peer" mediante recfrom() con timeout da select.
//				Restituisce il numero di caratteri letti o -1.
// Author(s):	TECMAV srl - av, cb
// L.M. Date:	09-Jan-2004 (12:39:55)

#include "_libsock.h"
#include "libDPR.h"


int SOCK_pthRecv(SockPeer_t *peer, char *msg, int size, int tout)
{
	int letti;					// Byte letti ad ogni read.
	int siz;					// Parametro per rcvfrom.
	struct timeval tv;
	fd_set rfd;
	int n;


	DPR3("[ SOCK_Recv(peer=0x%X, msg=0x%x, tout=%d)\n",
		(int)peer, (int)msg, tout)

	errno = 0;			// Se fossero sporchi ...

	siz = sizeof(struct sockaddr_in);

	FD_ZERO(&rfd);
	FD_SET(peer->sd, &rfd);

	tv.tv_sec = tout;
	tv.tv_usec = 0;

	switch(n = select(1 + peer->sd, &rfd, 0, 0, &tv))
	{
		case -1:
			DPR0("Select error\n")
			return -1;

		case 0:
			DPR0("Select timeout\n")
			return -1;

		default:

			letti = recvfrom(	peer->sd,
								msg,
								(size_t)size,
								0,
								(struct sockaddr *)(peer->soc),
								&siz
							);
			return(letti);
			break;
	}

}
