// Library		libSOCK - Machine independent Socket I/O functions.
// File:		libSOCK.h
// Description: Public headers.
// Author(s):	TECMAV srl - av/cb
// L.M. Date:	05-Dec-2003 (16:30:26)

#undef SYS_DEFINED

#ifdef Os_ECOS
#define SYS_DEFINED
#include <network.h>
#define INIT_NETWORK init_all_network_interfaces();
#define SET_ADDR_LEN(S) S.sin_len = sizeof(S);
#else
#endif

#if defined(Os_Linux) || defined(Os_QNX)
#define SYS_DEFINED
#include <sys/time.h>
#define INIT_NETWORK
#define SET_ADDR_LEN(S)
#endif

#ifdef Os_FreeBSD
#define SYS_DEFINED
#define INIT_NETWORK
#endif

#ifdef Os_RTEMS
#define SYS_DEFINED
#define INIT_NETWORK
#define SET_ADDR_LEN(S)
#include <sys/param.h>
#include <sys/socket.h>
#include <netinet/in.h>
#endif

#ifndef SYS_DEFINED
Abort this compilation !!!!!!!!!!
#endif


#ifdef DEBUG
#define DPR_SOC(X) SOCK_DPR(X);
#else
#define DPR_SOC(X)
#endif

#define dPR_SOC


// Descrittore di un collegamento UDP (unicast/multicast/...)

typedef struct SOCKPEER_t
{
	int		sd;					// Socket id.
	int		i_ip;				// Indirizzo IP.
	char 	s_ip[16];			// Indirizzo IP.
	int		port;				// Porta TCP.
	char 	soc[128];			// Struct sockaddr_in come char array per
								// semplificare gli include del processo user.
}
SockPeer_t;

extern int SOCK_Accept(int);
extern int SOCK_HAddr(char *);
extern int SOCK_Read(int, char *, int, int);
extern int SOCK_Send(SockPeer_t *, char *, int);
extern int SOCK_Write(int, char *, int, int);
extern int SOCK_Client(char *, int, int);
extern int SOCK_HAddrSI(char *, char *, int *);
extern int SOCK_Recv(SockPeer_t *, char *, int, int);
extern int SOCK_pthRecv(SockPeer_t *, char *, int, int);
extern int SOCK_ServerF(int, int);
extern int SOCK_Server(int, int);
extern int SOCK_Listen(int, int);
extern void SOCK_DPR(void *);
extern int SOCK_Peer(char *, int, SockPeer_t *);
extern int SOCK_SAddr(int, char *, int *);
extern int SOCK_GetTout(void);
extern int SOCK_SetTout(int);
